/*
 * heart.c
 *
 * Created: 15.01.2012 10:46:00
 *  Author: Lekarto
 */ 

#include <avr/io.h>
#include <avr/interrupt.h>// 
#include <avr/eeprom.h>

#define nop() {asm("nop");}//    "nop"

unsigned int k, i;
unsigned char a=0, m;

void port_and()
{
		  if (a>2) goto m_2;
		  if(a==0)
			{
              PORTC = PORTC & 0b11011111; // C5
			  return;
            }
          if(a==1)
		    {
              PORTC=PORTC & 0b11101111; // C4
			  PORTD=PORTD & 0b11111110; // D0
			  return;
            }
        //  if(a==2)
			{  
              PORTC=PORTC & 0b11110111; // C3
			  PORTD=PORTD & 0b11111101; // D1
			  return;
			}
	m_2:  if (a>5) goto m_5;
	      if(a==3)
			{  
              PORTC=PORTC & 0b11111011; // C2
			  PORTD=PORTD & 0b11111011; // D2
			  return;
            }
		  if(a==4)
			{  
              PORTC=PORTC & 0b11111101; // C1
			  PORTD=PORTD & 0b11110111; // D3
			  return;
            }
		 // if(a==5)
			{  
              PORTC=PORTC & 0b11111110; // C0
			  PORTD=PORTD & 0b11101111; // D4
			  return;
            }
   m_5:  if(a==6)
			{  
              PORTB=PORTB & 0b11110111; // B3
			  PORTD=PORTD & 0b11011111; // D5
			  return;
            }
		  if(a==7)
			{  
              PORTB=PORTB & 0b11111011; // B2
			  PORTD=PORTD & 0b10111111; // D6
			  return;
            }
		  if(a==8)
			{  
              PORTB=PORTB & 0b11111101; // B1
			  PORTD=PORTD & 0b01111111; // D7
			  return;
            }
          PORTB=PORTB & 0b11111110; // B0
}

void port_or()
{
		  if (a>2) goto m_b2;
		  if(a==0)
			{
              PORTC = PORTC | 0b00100000; // C5
			  return;
            }
          if(a==1)
			{
              PORTC=PORTC | 0b00010000; // C4
			  PORTD=PORTD | 0b00000001; // D0
			  return;
            }
         // if(a==2)
			{  
              PORTC=PORTC | 0b00001000; // C3
			  PORTD=PORTD | 0b00000010; // D1
			  return;
            }
   m_b2:  if (a>5) goto m_b5;
		  if(a==3)
			{  
              PORTC=PORTC | 0b00000100; // C2
			  PORTD=PORTD | 0b00000100; // D2
			  return;
            }
		  if(a==4)
			{  
              PORTC=PORTC | 0b00000010; // C1
			  PORTD=PORTD | 0b00001000; // D3
			  return;
            }
        // if(a==5)
			{  
              PORTC=PORTC | 0b00000001; // C0
			  PORTD=PORTD | 0b00010000; // D4
			  return;
            }
   m_b5: if(a==6)
			{  
              PORTB=PORTB | 0b00001000; // B3
			  PORTD=PORTD | 0b00100000; // D5
			  return;
            }
	      if(a==7)
			{  
              PORTB=PORTB | 0b00000100; // B2
			  PORTD=PORTD | 0b01000000; // D6
			  return;
            }
		  if(a==8)
			{  
              PORTB=PORTB | 0b00000010; // B1
			  PORTD=PORTD | 0b10000000; // D7
			  return;
            }
          PORTB=PORTB | 0b00000001; // B0
}

void port_and_1()
{
		  if (a>3) goto m_3;
		  if(a==1)
			{
              PORTC=PORTC & 0b11011111; // C5
			  PORTB=PORTB & 0b11111110; // B0
			  return;
            }
          if(a==2)
		    {
              PORTB=PORTB & 0b11111101; // B1
			  PORTD=PORTD & 0b11111110; // D0
			  return;
            }
        //  if(a==3)
			{  
              PORTB=PORTB & 0b11111011; // B2
			  PORTD=PORTD & 0b11111101; // D1
			  return;
			}
	m_3:  if (a>6) goto m_6;
	      if(a==4)
			{  
              PORTB=PORTB & 0b11110111; // B3
			  PORTD=PORTD & 0b11111011; // D2
			  return;
            }
		  if(a==5)
			{  
              PORTC=PORTC & 0b11111110; // C0
			  PORTD=PORTD & 0b11110111; // D3
			  return;
            }
		 // if(a==6)
			{  
              PORTC=PORTC & 0b11111101; // C1
			  PORTD=PORTD & 0b11101111; // D4
			  return;
            }
   m_6:  if(a==7)
			{  
              PORTC=PORTC & 0b11111011; // C2
			  PORTD=PORTD & 0b11011111; // D5
			  return;
            }
		  if(a==8)
			{  
              PORTC=PORTC & 0b11110111; // C3
			  PORTD=PORTD & 0b10111111; // D6
			  return;
            }
		  //if(a==9)
			{  
              PORTC=PORTC & 0b11101111; // C4
			  PORTD=PORTD & 0b01111111; // D7
			  return;
            }
         //PORTB=PORTB & 0b11111110; // B0
}

void port_or_1()
{
		  if (a>3) goto m_b3;
		  if(a==1)
			{
              PORTC = PORTC | 0b00100000; // C5
			  PORTB = PORTB | 0b00000001; // B0
			  return;
            }
          if(a==2)
			{
              PORTB=PORTB | 0b00000010; // B1
			  PORTD=PORTD | 0b00000001; // D0
			  return;
            }
         // if(a==3)
			{  
              PORTB=PORTB | 0b00000100; // B2
			  PORTD=PORTD | 0b00000010; // D1
			  return;
            }
   m_b3:  if (a>6) goto m_b6;
		  if(a==4)
			{  
              PORTB=PORTB | 0b00001000; // B3
			  PORTD=PORTD | 0b00000100; // D2
			  return;
            }
		  if(a==5)
			{  
              PORTC=PORTC | 0b00000001; // C0
			  PORTD=PORTD | 0b00001000; // D3
			  return;
            }
        // if(a==6)
			{  
              PORTC=PORTC | 0b00000010; // C1
			  PORTD=PORTD | 0b00010000; // D4
			  return;
            }
   m_b6: if(a==7)
			{  
              PORTC=PORTC | 0b00000100; // C2
			  PORTD=PORTD | 0b00100000; // D5
			  return;
            }
	      if(a==8)
			{  
              PORTC=PORTC | 0b00001000; // C3
			  PORTD=PORTD | 0b01000000; // D6
			  return;
            }
		  //if(a==9)
			{  
              PORTC=PORTC | 0b00010000; // C4
			  PORTD=PORTD | 0b10000000; // D7
			  return;
            }
          //PORTB=PORTB | 0b00000001; // B0
}


int main(void)
{


PORTB=0x00; //    1
DDRB=0xFF;  //    
PORTC=0x00; //    1
DDRC=0xFF;  //    
PORTD=0x00; //    1
DDRD=0xFF;  //    




while (1)
  {     
    
//--------------------------
//     
    a=1;
	while (1)
	{
	  //  
	  k=3000;
	  while(k>1) {
	  for(i=1; i<=k; i=i+1)
		  port_and_1(a);
	  for(i=k; i<=3000; i=i+1)
          port_or_1(a);
      k=k-50;
	}  //  
    a=++a % 9;
	if (a==0)
	  break;
	}
//-------------------------	
//     0   
  a=5;
  while (a>0) {
	k=3000;
	while (k>1) {
	  for (i=k;i<3000;i++)	  
	    PORTB=PORTC=PORTD=0x00;
	  for (i=1;i<k;i++)
	    PORTB=PORTC=PORTD=0xFF;
	  k=k-25;
	}
//-------------------------
//---      0
    k=3000;
	while (k>1) {
	  for (i=1;i<k;i++)
	    PORTB=PORTC=PORTD=0x00;
	  for (i=k;i<3000;i++)
	    PORTB=PORTC=PORTD=0xFF;
	  k=k-100;
	}	
    a=a-1;
  }	 

//---------------------
//    
  a=m=0;
  while (m<5) {
    a=0;
    while (a<10) {
      k=3000;
      while(k>1){
        for (i=k;i<3000;i++)
	      port_and(a);
	    for (i=1;i<k;i++)
	      port_or(a);
	    k=k-500;
      }
	  a=a+1;
    } 
    m=m+1;
  }
    
//------------------------
//     
  a=0;
  while (a<10) {
    k=3000;
    while(k>1){
	  for (i=1;i<k;i++)
	    port_or(a);
	  for (i=k;i<3000;i++)
	    port_and(a);
		
	  k=k-500;
    }
	a=a+1;
  }
   //  _ !!!!
   PORTB=PORTC=PORTD=0xFF; 
//------------------------
//   
  a=9;
  while(1)	
  {
	  //   
	  k=3000;
    while(k>1){
	  for(i=k; i<=3000; i=i+1) 
          port_and_1(a);
	  for(i=1; i<=k; i=i+1)
          port_or_1(a);
      k=k-50;
	} //  
//    0   
    port_and_1(a);
	a= --a;
	if (a==0)
	  break;
  } 
//-----------------------------
//   0
  a=5;
  while (a>0) {
    k=3000;
	while (k>1) {
	  for (i=1;i<k;i++)
	    PORTB=PORTC=PORTD=0x00;
	  for (i=k;i<3000;i++)
	    PORTB=PORTC=PORTD=0xFF;
	  k=k-25;
	}
	k=3000;
	while (k>1) {
	  for (i=k;i<3000;i++)	  
	    PORTB=PORTC=PORTD=0x00;
	  for (i=1;i<k;i++)
	    PORTB=PORTC=PORTD=0xFF;
	  k=k-100;
	}
    a=a-1;
  } 
//-----------------------
// -  , -  
  m=0;
  while (m<3) {
    a=0;
    while (a<10) {
      k=3000;
      while(k>1){
        for (i=k;i<3000;i++)
	      port_and(a);
	    for (i=1;i<k;i++)
	      port_or(a);
	    k=k-500;
      }
	  a=a+1;
    }
	//
    a=0;
    while (a<10) {
      k=3000;
      while(k>1){
        for (i=k;i<3000;i++)
	      port_or(a);
	    for (i=1;i<k;i++)
	      port_and(a);
	    k=k-500;
      }
	  a=a+1;
	}	 
	//
	a=1;
	while (1)
	  {
	  //  
	    k=3000;
	    while(k>1) {
	    for(i=1; i<=k; i=i+1)
		  port_and_1(a);
	    for(i=k; i<=3000; i=i+1)
          port_or_1(a);
        k=k-500;
	  }  //  
      a=++a % 10;
	  if (a==0)
	    break;
	  }
	//
	
	a=1;
    while(1)	
      {
	    //   
	    k=3000;
        while(k>1){
	    for(i=k; i<=3000; i=i+1) 
          port_and_1(a);
	    for(i=1; i<=k; i=i+1)
          port_or_1(a);
        k=k-500;
	  } //  
	  //    0   
      port_and_1(a);
	  a= ++a% 10;
	  if (a==0)
	    break;
      } 
	//
    m=m+1;
  }
//-------------------- 
  
  
  
  PORTB=PORTC=PORTD=0x00; 
  }; 
} 